<template>
  <div id="template">
    <div id="main-content">
      <div id="presentation">
        <div id="explication">
          <div>
            <h1>Astronospot</h1>
            Bienvenue sur Astronospot, nous sommes une petite application
            développée par 4 étudiants, cette appli vous permet de trouver les
            meilleures spots d'observations du ciel affichés sur la carte,
            suivant la météo pour une observation dans les meilleures
            conditions. Enjoy !
          </div>
        </div>
      </div>
      <div id="map">Map Reduite</div>
    </div>
    <div id="aside-content">
      <div id="news">
        Evenements News
        <ul>
          <li v-for="event in skyEvents" :key="event.date">
            <a>{{ event.date }}: {{ event.nom }}</a>
          </li>
        </ul>
      </div>

      <div class="card card-weather" v-for="m in meteo" :key="m.date">
        <div class="card-body">
          <div class="weather-date-location">
            <h3>Météo de</h3>
            <span class="weather-location"> --- </span>
            <p class="text-gray">
              <span class="weather-date"> Aujourd'hui </span>
              <span class="icon"><img v-bind:src="m.meteoPicture" /></span>
            </p>
          </div>
          <div class="weather-data d-flex">
            <div class="mr-auto">
              <h4 class="display-3">
                {{ m.tmin }} - {{ m.tmax }} <span class="symbol">°</span>C
              </h4>
              <h4>Ensoleillement: {{ m.sunHours }}h</h4>
            </div>
          </div>
        </div>
        <div class="card-body p-0">
          <div class="d-flex weakly-weather">
            <div class="weakly-weather-item" v-for="m in meteo" :key="m.date">
              <p class="mb-0">
                {{ moment(m.date).format("dddd, DD-MM-YYYY") }}
              </p>
              <img v-bind:src="m.meteoPicture" />
              <p class="mb-0">{{ m.tmax }}</p>
              <p class="mb-0">{{ m.tmin }}</p>
            </div>
          </div>
        </div>
      </div>
      <!--weather card ends-->
    </div>
  </div>
</template>

<script>
// import Vue from 'vue'
// import moment from 'moment'
import mapboxgl from 'mapbox-gl/dist/mapbox-gl.js'
// eslint-disable-next-line no-unused-vars

mapboxgl.accessToken =
  'pk.eyJ1IjoibGxlZGluaCIsImEiOiJja2pza3dzb2sxMmtvMnpqeDg1bnJldzB4In0.AtwAS_tK-RbadW7ikVcL5g'
// eslint-disable-next-line no-unused-vars

export default {
  updated () {},
  data: function () {
    return {
      meteo: '',
      latlng: [],
      skyEvents: [],
      meteoPictures: {
        0: 'day.svg', // Soleil
        1: 'cloudy-day-1.svg', // Peu nuageux
        2: 'cloudy-day-1.svg', // Ciel voilé
        3: 'cloudy-day-2.svg', // Nuageux
        4: 'cloudy.svg', // Très nuageux
        5: 'cloudy.svg', // Couvert
        6: 'cloudy.svg', // Brouillard
        7: 'cloudy.svg', // Brouillard givrant
        10: 'rainy-2.svg', // Pluie faible
        11: 'rainy-1.svg', // Pluie modérée
        12: 'rainy-5.svg', // Pluie forte
        13: 'rainy-5.svg', // Pluie faible verglaçante
        14: 'rainy-5.svg', // Pluie modérée verglaçante
        15: 'rainy-5.svg', // Pluie forte verglaçante
        16: 'rainy-7.svg', // Bruine
        20: 'snowy-2.svg', // Neige faible
        21: 'snowy-3.svg', // Neige modérée
        22: 'snowy-6.svg', // Neige forte
        30: 'rainy-6.svg', // Pluie et neige mêlées faibles
        31: 'rainy-6.svg', // Pluie et neige mêlées modérées
        32: 'rainy-6.svg', // Pluie et neige mêlées fortes
        40: 'rainy-2.svg', // Averses de pluie locales et faibles
        41: 'rainy-2.svg', // Averses de pluie locales
        42: 'rainy-2.svg', // Averses locales et fortes
        43: 'rainy-2.svg', // Averses de pluie faibles
        44: 'rainy-2.svg', // Averses de pluie
        45: 'rainy-5.svg', // Averses de pluie fortes
        46: 'rainy-2.svg', // Averses de pluie faibles et fréquentes
        47: 'rainy-2.svg', // Averses de pluie fréquentes
        48: 'rainy-2.svg', // Averses de pluie fortes et fréquentes
        60: 'snowy-4.svg', // Averses de neige localisées et faibles
        61: 'snowy-4.svg', // Averses de neige localisées
        62: 'snowy-6.svg', // Averses de neige localisées et fortes
        63: 'snowy-4.svg', // Averses de neige faibles
        64: 'snowy-4.svg', // Averses de neige
        65: 'snowy-6.svg', // Averses de neige fortes
        66: 'snowy-6.svg', // Averses de neige faibles et fréquentes
        67: 'snowy-6.svg', // Averses de neige fréquentes
        68: 'snowy-6.svg', // Averses de neige fortes et fréquentes
        70: 'rainy-6.svg', // Averses de pluie et neige mêlées localisées et faibles
        71: 'rainy-6.svg', // Averses de pluie et neige mêlées localisées
        72: 'rainy-5.svg', // Averses de pluie et neige mêlées localisées et fortes
        73: 'rainy-6.svg', // Averses de pluie et neige mêlées faibles
        74: 'rainy-6.svg', // Averses de pluie et neige mêlées
        75: 'rainy-5.svg', // Averses de pluie et neige mêlées fortes
        76: 'rainy-6.svg', // Averses de pluie et neige mêlées faibles et nombreuses
        77: 'rainy-5.svg', // Averses de pluie et neige mêlées fréquentes
        78: 'snowy-6.svg', // Averses de pluie et neige mêlées fortes et fréquentes
        100: 'thunder.svg', // Orages faibles et locaux
        101: 'thunder.svg', // Orages locaux
        102: 'thunder.svg', // Orages fort et locaux
        103: 'thunder.svg', // Orages faibles
        104: 'thunder.svg', // Orages
        105: 'thunder.svg', // Orages forts
        106: 'thunder.svg', // Orages faibles et fréquents
        107: 'thunder.svg', // Orages fréquents
        108: 'thunder.svg', // Orages forts et fréquents
        120: 'thunder.svg', // Orages faibles et locaux de neige ou grésil
        121: 'thunder.svg', // Orages locaux de neige ou grésil
        122: 'thunder.svg', // Orages locaux de neige ou grésil
        123: 'thunder.svg', // Orages faibles de neige ou grésil
        124: 'thunder.svg', // Orages de neige ou grésil
        125: 'thunder.svg', // Orages de neige ou grésil
        126: 'thunder.svg', // Orages faibles et fréquents de neige ou grésil
        127: 'thunder.svg', // Orages fréquents de neige ou grésil
        128: 'thunder.svg', // Orages fréquents de neige ou grésil
        130: 'thunder.svg', // Orages faibles et locaux de pluie et neige mêlées ou grésil
        131: 'thunder.svg', // Orages locaux de pluie et neige mêlées ou grésil
        132: 'thunder.svg', // Orages fort et locaux de pluie et neige mêlées ou grésil
        133: 'thunder.svg', // Orages faibles de pluie et neige mêlées ou grésil
        134: 'thunder.svg', // Orages de pluie et neige mêlées ou grésil
        135: 'thunder.svg', // Orages forts de pluie et neige mêlées ou grésil
        136: 'thunder.svg', // Orages faibles et fréquents de pluie et neige mêlées ou grésil
        137: 'thunder.svg', // Orages fréquents de pluie et neige mêlées ou grésil
        138: 'thunder.svg', // Orages forts et fréquents de pluie et neige mêlées ou grésil
        140: 'thunder.svg', // Pluies orageuses
        141: 'thunder.svg', // Pluie et neige mêlées à caractère orageux
        142: 'thunder.svg', // Neige à caractère orageux
        210: 'rainy-2.svg', // Pluie faible intermittente
        211: 'rainy-2.svg', // Pluie modérée intermittente
        212: 'rainy-5.svg', // Pluie forte intermittente
        220: 'snowy-4.svg', // Neige faible intermittente
        221: 'snowy-6.svg', // Neige modérée intermittente
        222: 'snowy-6.svg', // Neige forte intermittente
        230: 'snowy-4.svg', // Pluie et neige mêlées
        231: 'snowy-4.svg', // Pluie et neige mêlées
        232: 'snowy-4.svg', // Pluie et neige mêlées
        235: 'snowy-4.svg' // Averses de grêle
      },
      description: [],
      name: []
    }
  },
  methods: {
    getLatlng: function () {
      return fetch('/spot')
        .then((response) => response.json())
        .then((data) => {
          console.log(data.data)
          const latlng = []
          let k = 0
          for (let i = 0; i < data.data.length; i++) {
            latlng[k] = data.data[i].latitude
            latlng[k + 1] = data.data[i].longitude
            k += 2
            this.description.push(data.data[i].description)
            this.name.push(data.data[i].nom)
          }
          this.latlng = latlng
        })
    },

    getSkyEvents: function () {
      return fetch('/sky-events')
        .then((response) => response.json())
        .then((data) => {
          this.skyEvents = data.data
        })
    },

    getMeteo: function (day) {
      const meteoPicture = '/meteoPictures/' + this.meteoPictures[day.weather]

      const meteo = {
        date: day.datetime,
        tmax: day.tmax,
        tmin: day.tmin,
        sunHours: day.sun_hours,
        weather: day.weather,
        meteoPicture: meteoPicture
      }

      return meteo
    },
    getMeteoCity: function (latlng) {
      fetch(
        'https://api.meteo-concept.com/api/forecast/daily?token=3fc32cd138c72793e506a863dabc4699591e46fcbfb66f3514a02e1aeeb02b19&latlng=' +
          latlng[0] +
          ',' +
          latlng[1]
      )
        .then((response) => response.json())
        .then((data) => {
          this.meteo = []
          data.forecast.forEach((element) => {
            const meteoDay = this.getMeteo(element)
            this.meteo.push(meteoDay)
          })
        })
    }
  },
  async mounted () {
    await this.getSkyEvents()
    await this.getLatlng()
    console.log('latng')
    console.log(this.latlng)
    this.getMeteoCity([this.latlng[0], this.latlng[1]])

    // eslint-disable-next-line no-unused-vars
    const map = new mapboxgl.Map({
      container: 'map',
      style: 'mapbox://styles/mapbox/streets-v11',
      center: [1.433333, 43.6],
      zoom: 11.15
    })

    // Add zoom and rotation controls to the map.
    map.addControl(new mapboxgl.NavigationControl())

    const features = []
    let k = 0
    for (let i = 0; i < this.latlng.length; i += 2) {
      const feature = {
        type: 'Feature',
        properties: {
          description:
            '<h1>' + this.name[k] + '</h1> <p>' + this.description[k] + '</p>'
        },
        geometry: {
          type: 'Point',
          coordinates: [this.latlng[i + 1], this.latlng[i]]
        }
      }
      k += 1
      features.push(feature)
    }
    // L'api mapbox et la base de données utilisent le format [longitude, latitude]
    // coordinates: [this.latlng[1], this.latlng[0]]

    // eslint-disable-next-line no-unused-vars
    const funcGetMeteoCity = this.getMeteoCity

    map.on('load', () => {
      map.loadImage(
        'https://docs.mapbox.com/mapbox-gl-js/assets/custom_marker.png',
        // Add an image to use as a custom marker
        function (error, image) {
          if (error) throw error
          map.addImage('custom-marker', image)
          map.addSource('places', {
            type: 'geojson',
            data: {
              type: 'FeatureCollection',
              features
            }
          })

          map.addLayer({
            id: 'places',
            type: 'symbol',
            source: 'places',
            layout: {
              'icon-image': 'custom-marker',
              'icon-allow-overlap': true
            }
          })
        }
      )
    })
    map.on('click', 'places', function (e) {
      var coordinates = e.features[0].geometry.coordinates.slice()
      var description = e.features[0].properties.description

      // // L'api meteo utilise le format [latitude,longitude]
      const meteoCoordinates = []
      meteoCoordinates[0] = coordinates[1]
      meteoCoordinates[1] = coordinates[0]
      funcGetMeteoCity(meteoCoordinates)

      // Ensure that if the map is zoomed out such that multiple
      // copies of the feature are visible, the popup appears
      // over the copy being pointed to.
      while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
        coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360
      }

      new mapboxgl.Popup()
        .setLngLat(coordinates)
        .setHTML(description)
        .addTo(map)
    })

    map.on('mouseenter', 'places', function () {
      map.getCanvas().style.cursor = 'pointer'
    })

    // Change it back to a pointer when it leaves.
    map.on('mouseleave', 'places', function () {
      map.getCanvas().style.cursor = ''
    })
  }
}
</script>

<style scoped>
#map {
  margin-top: 20px;
  width: 100%;
  height: 500px;
}
.mapboxgl-popup {
  max-width: 400px;
  font: 12px/20px "Helvetica Neue", Arial, Helvetica, sans-serif;
}
.mapboxgl-marker {
  width: 20px;
}

#template {
  display: flex;
}
#main-content {
  flex: 0 0 65%;
  text-align: justify;
}
#aside-content {
  flex: 0 0 25%;
  padding: 20px;
}

#presentation {
  background: url("https://images.pexels.com/photos/110854/pexels-photo-110854.jpeg?auto=compress&cs=tinysrgb&dpr=2&h=650&w=940");
}

#explication {
  color: white;
  padding: 30px 40px;
  width: 50%;
  font-size: 24px;
  height: 600px;
  display: flex;
  align-items: center;
}

#explication div {
  background-color: #00000087;
  padding: 20px;
  border-radius: 10px;
}

#explication h1 {
  text-transform: uppercase;
  font-family: "fontawesome";
}
.card-weather .card-body:first-child {
  background: url(https://res.cloudinary.com/dxfq3iotg/image/upload/v1557323760/weather.svg)
    no-repeat center;
  background-size: cover;
}

.card .card-body {
  padding: 1rem 1rem;
}

.card-body {
  flex: 1 1 auto;
  padding: 1.25rem;
}

.card-weather .weather-date-location {
  padding: 0 0 38px;
}
.text-gray,
.card-subtitle,
.new-accounts ul.chats li.chat-persons a p.joined-date {
  color: #969696;
}

p {
  font-size: 13px;
}

.text-gray,
.card-subtitle,
.new-accounts ul.chats li.chat-persons a p.joined-date {
  color: #969696;
}

.card-weather .weather-data {
  padding: 0 0 4.75rem;
}

.mr-auto,
 .mx-auto {
     margin-right: auto !important
 }

.display-3 {
  font-size: 2.5rem;
}

.card-weather .card-body {
  background: #ffffff;
}

.card-weather .weakly-weather {
  background: #ffffff;
  overflow-x: auto;
}
.card-weather .weakly-weather .weakly-weather-item {
  flex: 0 0 14.28%;
  border-right: 1px solid #f2f2f2;
  text-align: center;
}
.icon {
  align-self: flex-end;
  margin-right: -2.5rem;
  margin-top: -2rem;
  z-index: 999;
}

.icon img {
  width: 20rem;
}
</style>
